#!/usr/bin/perl -w
# ******************************************
# *
# * Fabin Salamanca (C) 2005
# *
# * Ejemplo de envo SOAP va POST en Perl
# *
# ******************************************

use strict;

use LWP::UserAgent;
use HTTP::Request::Common;
my $userAgent = LWP::UserAgent->new(agent => 'perl post');
my $message = " <!-- <?xml version=\"1.0\" encoding=\"UTF-8\"?> -->
<soap:envelope soap="\&quot;http://schemas.xmlsoap.org/soap/envelope/\&quot;"><!-- <?xml version=\"1.0\" encoding=\"UTF-8\"?> -->
<soap:envelope soap="\&quot;http://schemas.xmlsoap.org/soap/envelope/\&quot;">
<soap:header>
  <header xmlns="\&quot;xmlapi_1.0\&quot;">
    <!-- Toda la parte de security es opcional -->
    <security>
      <user>user</user>
      <password>password</password>
   </security>
   <requestid>client1:0</requestid>
 </header>
</soap:header>
<!-- Este es un ejemplo de listado de equipo de red (service router Alcatel) -->
<soap:body>
      <equipment.card.finddaughtercards xmlns="\&quot;xmlapi_1.0\&quot;">
        <deployer>immediate</deployer>
        <instancefullname>network:10.1.1.2:shelf-1:cardSlot-1:card
         </instancefullname>
        <list>
      </list>
</equipment.card.finddaughtercards>
</soap:body>";<soap:header><header xmlns="\&quot;xmlapi_1.0\&quot;"></header></soap:header><soap:body><equipment.card.finddaughtercards xmlns="\&quot;xmlapi_1.0\&quot;"><list></list></equipment.card.finddaughtercards></soap:body>
my $response = $userAgent->request(POST 'http://190.1.2.3:8080/xmlapi/invoke',
Content_Type => 'text/xml',
Content => $message);

# Esto es para formatear la salida para un navegador, funciona como CGI

print "Content-type: text/xml\n\n";
print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
my $xmlresult=substr($response->as_string,232);
print $xmlresult;
